/*
   Esercizio: intersezione tra insiemi.
   Scrivere un programma che accetti in input dall’utente due sequenze di interi distinti e stampi gli
   elementi che occorrono in entrambe. Assumere che l’utente specifichi la lunghezza di ogni sequenza
   prima di immettere tutti i suoi elementi.

   Questa soluzione lavora in tempo O(|A|*|B|), dove |A| e |B| sono il numero di elementi in A e in B. 
   In seguito studieremo una tecnica più efficiente basata sull'ordinamento. 

*/


#include <stdlib.h>
#include <stdio.h>


/* 
   Funzione per la lettura dell'input.
   Accetta due parametri passati per riferimento: un puntatore ad int A, e una variabile intera len.
   Al ritorno dalla funzione, A punterà ad un array contenente la sequenza di elementi inserita e 
   len conterrà la lunghezza di tale sequenza  
*/

void leggiInput(int **A, int *len){

int i;
scanf("%d",len);		    // il primo valore inserito è la lunghezza	
*A = malloc((*len) * sizeof(int));
if (*A == NULL) return;

 for (i=0; i< *len; i++)
  scanf("%d",(*A) + i);

}


int main(){

 int *A, lenA;             // A: puntatore ad array contentente gli elementi di A. lenA: numero di elementi di A
 int *B, lenB;             // idem per B
 int i,j;

 /* lettura dell'input tramite la funzione leggiInput, che inizializza le variabili A,B,lenA e lenB */
 
 leggiInput(&A, &lenA);   
 leggiInput(&B, &lenB);   

 if (A== NULL || B == NULL) return 1;

 /* Coppia di for annidati che stampa l'intersezione confrontando ogni elemento di A con 
   ogni elemento di B  */

 for (i=0; i < lenA; i++)
  for (j=0; j < lenB; j++) {
     if (A[i] == B[j]) 
       printf("%d ",A[i]);
  }

 printf("\n");

 /* Richiede tempo O(lenA * lenB), scopriremo che esiste una tecnica più efficiente basata sull'ordinamento */

 return 0;

}
